//+------------------------------------------------------------------+
//|                                         direction congestion.mq4 |
//|                                                                  |
//| eSignal source coversaion                                        |
//| made at a request from ftsdean                                   |
//| made by mladen                                                   |
//+------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1  clrDeepSkyBlue 
#property indicator_color2  clrSandyBrown
#property indicator_width1  2
#property indicator_width2  2


//
//
//
//
//

extern int                dciPeriod    = 9;
extern ENUM_APPLIED_PRICE rsiPrice     = PRICE_CLOSE;
extern int                rsiPeriod    = 21;
extern int                rsiUpValue   = 52;
extern int                rsiDownValue = 48;
extern double             constant     = 4.0;

//
//
//
//
//

double dupBuffer[];
double ddnBuffer[];
double cenBuffer[];
double avnBuffer[];
double uppBuffer[];
double lowBuffer[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(6);
      SetIndexBuffer(0,dupBuffer); SetIndexStyle(0,DRAW_ARROW); SetIndexArrow(0,159);
      SetIndexBuffer(1,ddnBuffer); SetIndexStyle(1,DRAW_ARROW); SetIndexArrow(1,159);
      SetIndexBuffer(2,cenBuffer);
      SetIndexBuffer(3,avnBuffer);
      SetIndexBuffer(4,uppBuffer);
      SetIndexBuffer(5,lowBuffer);
      
      //
      //
      //
      //
      //
                           
   IndicatorShortName("Direction congestion ( "+dciPeriod+","+rsiPeriod+")");         
   return(0);
}

int deinit()
{
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int limit,i;

   if(counted_bars < 0)   return(-1);
   if(counted_bars > 0)   counted_bars--;
           limit = MathMax(Bars-counted_bars,Bars-1);
                       
   //
   //
   //
   //
   //

      for(i = limit; i >= 0; i--)
      {
         if (i==(Bars-1))
         {
            cenBuffer[i] = Close[i];
            avnBuffer[i] = High[i]-Low[i];
            uppBuffer[i] = cenBuffer[i]+avnBuffer[i]*constant;
            lowBuffer[i] = cenBuffer[i]-avnBuffer[i]*constant;
            continue;
         }
         
         //
         //
         //
         //
         //
         
         cenBuffer[i] = (cenBuffer[i+1]*(dciPeriod-1)+Close[i]      )/dciPeriod;
         avnBuffer[i] = (avnBuffer[i+1]*(dciPeriod-1)+High[i]-Low[i])/dciPeriod;
         uppBuffer[i] =  cenBuffer[i]+avnBuffer[i]*constant;
         lowBuffer[i] =  cenBuffer[i]-avnBuffer[i]*constant;
         dupBuffer[i] = (cenBuffer[i+1]+uppBuffer[i+1])/2.0;
         ddnBuffer[i] = (cenBuffer[i+1]+lowBuffer[i+1])/2.0;
         
         double rsi = iRSI(NULL,0,rsiPeriod,rsiPrice,i);
            if (rsi > rsiUpValue)   dupBuffer[i] = EMPTY_VALUE;
            if (rsi < rsiDownValue) ddnBuffer[i] = EMPTY_VALUE;
      }
   return(0);      
}